/*
 *  linux/drivers/mmc/s3c2410mci.h - Samsung S3C2410 SDI Interface driver
 *
 *  Copyright (C) 2004 Thomas Kleffel, All Rights Reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as
 * published by the Free Software Foundation.
 */

struct clk;

//FIXME: DMA Resource management ?!
#define S3C2410SDI_DMA 0

enum s3c2410sdi_waitfor {
	COMPLETION_NONE,
	COMPLETION_CMDSENT,
	COMPLETION_RSPFIN,
	COMPLETION_XFERFINISH,
	COMPLETION_XFERFINISH_RSPFIN,
};

struct s3c2410sdi_host {
	struct mmc_host		*mmc;

	struct resource		*mem;
	struct clk		*clk;
	void __iomem		*base;
	int			irq;
	int			irq_cd;
	int			dma;
	
	unsigned long		real_rate;
	u8			prescaler;

	int			is2440;
	int			fix2410;
	int			dodma;

	volatile int		dmatogo;

	struct mmc_request	*mrq;
	int			cmd_is_stop;

	spinlock_t		complete_lock;
	volatile enum s3c2410sdi_waitfor	
				complete_what;
		
	volatile int		dma_complete;
	
	u32			pio_sgptr;
	u32			pio_words;
	u32			*pio_ptr;
#define XFER_NONE 0
#define XFER_READ 1
#define XFER_WRITE 2
	u32			pio_active;
	
	char 			dbgmsg_cmd[301];
	char 			dbgmsg_dat[301];

	unsigned int		ccnt, dcnt;	
};
